



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[MethodImpl(MethodImplOptions.Synchronized)]</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[MethodImpl(MethodImplOptions.Synchronized)]</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:32:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在NopCommerce项目的Nop.Core类库中有一个EngineContext类中有一个Initialize方法用到了[MethodImpl(MethodImplOptions.Synchronized)]</p>
<div>
<pre class="prettyprint linenums"> /// &lt;summary&gt;<br />
        /// Initializes a static instance of the Nop factory.<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="forceRecreate"&gt;Creates a new factory instance even though the factory has been previously initialized.&lt;/param&gt;<br />
        [MethodImpl(MethodImplOptions.Synchronized)]<br />
        public static IEngine Initialize(bool forceRecreate)<br />
        {<br />
            if (Singleton&lt;IEngine&gt;.Instance == null || forceRecreate)<br />
            {<br />
                var config = ConfigurationManager.GetSection("NopConfig") as NopConfig;<br />
                Singleton&lt;IEngine&gt;.Instance = CreateEngineInstance(config);<br />
                Singleton&lt;IEngine&gt;.Instance.Initialize(config);<br />
            }<br />
            return Singleton&lt;IEngine&gt;.Instance;<br />
        }</pre>
</div>
<p>我的理解它和Lock差不多，是解决多线程同步问题的；</p>
<p>该方法一次只能由一个线程执行。 静态方法锁定类型，而实例方法锁定实例。 在任何实例函数中只能执行一个线程，并且在类的任何静态函数中只能执行一个线程。</p>
<ul><li>如果[MethodImplAttribute(MethodImplOptions.Synchronized)]被应用到instance method，相当于对当前实例加锁。</li>
<li>如果[MethodImplAttribute(MethodImplOptions.Synchronized)]被应用到static method，相当于当前类型加锁。</li></ul>
<h1>实例方法锁定实例</h1>
<div>
<pre class="prettyprint linenums">class Program<br />
    {<br />　　　　//在入口Main方法中，创建SyncHelper对象，通过一个System.Threading.Timer对象实现每隔1s调用该对象的Execute方法：<br />
        static void Main(string[] args)<br />
        {<br />
            SyncHelper sync = new SyncHelper();<br />
            Timer timer = new Timer(delegate<br />
            {<br />
                sync.Execute();<br />
            }, null, , );

            Console.ReadKey();<br />
        }<br />
    }

    class SyncHelper<br />
    {<br />
        public void Execute()<br />
        {<br />
            Console.WriteLine("Excute at {0}", DateTime.Now);<br />
            Thread.Sleep();<br />
        }<br />
    }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/70919/201507/241435560371845.png" /></p>
<div>
<pre class="prettyprint linenums"> class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            SyncHelper sync = new SyncHelper();<br />
            Timer timer = new Timer(delegate<br />
            {<br />
                sync.Execute();<br />
            }, null, , );

            Console.ReadKey();<br />
        }<br />
    }

    class SyncHelper<br />
    {<br />
        [MethodImpl(MethodImplOptions.Synchronized)]<br />
        public void Execute()<br />
        {<br />
            Console.WriteLine("Excute at {0}", DateTime.Now);<br />
            Thread.Sleep();<br />
        }<br />
    }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/70919/201507/241438490531289.png" /></p>
<h1>静态方法锁定类型</h1>
<div>
<pre class="prettyprint linenums"> class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            SyncHelper sync = new SyncHelper();<br />
            Timer timer = new Timer(delegate<br />
            {<br />
                SyncHelper.Execute();<br />
            }, null, , );

            Console.ReadKey();<br />
        }<br />
    }

    class SyncHelper<br />
    {<br />
        [MethodImpl(MethodImplOptions.Synchronized)]<br />
        public static void Execute()<br />
        {<br />
            Console.WriteLine("Excute at {0}", DateTime.Now);<br />
            Thread.Sleep();<br />
        }<br />
    }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/70919/201507/241635019121773.png" /></p>
<p>例子：http://www.cnblogs.com/artech/archive/2008/10/17/1313209.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ppvqz.html">IdentityServer4 使用OpenID Connect添加用户身份验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql11519.html">基础理解1&colon;JSONP</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvd0ooq.html">Marquee 滚动参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q241vl8.html">Idea 201601注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2on6l9.html">&amp;ldquo&semi;耐撕&amp;rdquo&semi;团队 2016&period;04&period;07 站立会议</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdkekm8.html">function和感叹号，运算符号的转化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpdw1q.html">OPENCV中滑动条的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8menrnpq.html">HDU1452Happy 2004（高次幂取模&plus;积性函数&plus;逆元）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zm5v8.html">WebServices 之 WSDL</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ykdl08.html">自制ZigBee协议分析仪</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge6wll8.html">python操作MySQL数据库并将数据写入excel</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdo0g49.html">PAT1041&colon; Be Unique</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kwzjq.html">js 控制随机数生成概率</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r55gkeq.html">opencv2&period;4&period;13&plus;python2&period;7学习笔记--opencv中的Gui特性--图片：读图像，显示图像，保存图像</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11e05q.html">java实现带空格字符串的倒序输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mk3y9.html">java基础之Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1dw6pq.html">Gedit浏览器常用快捷键备注</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj0vo79.html">HTML常用特殊字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ezz3q.html">KMP算法&mdash;&mdash;从入门到懵逼到了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pwgw08.html">MySQL 插入emoji 表情</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4y336nq.html">【转】android新建项目时 出现appcompat&lowbar;v7工程错误和红色感叹号</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj225k9.html">【转】 COCOS2D-X之使用CURL下载图片的一个简单Demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okl23e9.html">手把手教你WEB套打程序开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1elln9.html">android Bitmap getByteCount和getRowBytes</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1elxn9.html">oracle server配置：监听程序未启动或数据库服务未注册到该监听程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz41y9.html">HDU 5266  pog loves szh III</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnrzz2q.html">任务栏窗口和状态图标的闪动 z</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1e2r39.html">bug描述注意点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qder2jx9.html">LinearLayout使用tips</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zw3y69.html">delphi -- 进制转换 函数表</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
